Bug 162259 - NFS v2/v3 inconsistency on reported size
NFS v2/v3 inconsistency on reported size
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel (Show other bugs)
3.0
x86_64 Linux
medium Severity medium
: ---
: ---
Assigned To: Steve Dickson
Brian Brock
:
Depends On:
Blocks: 170417
  Show dependency treegraph
 
Reported: 2005-07-01 15:25 EDT by Tru Huynh
Modified: 2007-11-30 17:07 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-10-19 14:59:21 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Tru Huynh 2005-07-01 15:25:37 EDT
Description of problem:

We have a NetApp exporting a snapshot tree.
The snapshot is mounted in nfs v2 and v3 on several opteron
machines.
The reported size by df(1) is inconsistent between v2 and v3
and worse is wrong according to the NetApp.

Version-Release number of selected component (if applicable):

coreutils-4.5.3-26 and kernel-smp-2.4.21-32.0.1.EL (from RHEL3)
coreutils-5.2.1-31.1 and kernel-smp-2.6.9-11.21.EL (from RHEL4)

How reproducible:
Always

Steps to Reproduce:
1. export a snapshot from a Netapp
2. mount the snapshot in nfsvers=2/3
3. df -P
  
Actual results:
on a x86_64 2.4.21-32.0.1.ELsmp RHEL3
df -P:
Filesystem         1024-blocks      Used Available Capacity Mounted on
emmental.xxx:/vol/banques/.snapshot 625152992 -590295810342221119488 17109660608
    101% /mount/banques_rel
emmental.xxx:/vol/banques/.snapshot 625152984 -147573952573191913472 17109660600
    101% /mount/banques_rel-v2
mount:
emmental.xxx:/vol/banques/.snapshot on /mount/banques_rel type nfs
(rw,addr=157.99.64.123)
emmental.xxx:/vol/banques/.snapshot on /mount/banques_rel-v2 type nfs
(rw,nfsvers=2,addr=157.99.64.123)

on a x86_64 2.6.9-11.ELsmp RHEL4:
df -P:
Filesystem         1024-blocks      Used Available Capacity Mounted on
emmental.xxx:/vol/banques/.snapshot nfs 625152984 -147573952573191800048
17109765864     101% /mount/banques_rel-v2
emmental.xxx:/vol/banques/.snapshot nfs 625152984 -147573952573191800048
17109765864     101% /mount/banques_rel
mount:
emmental.xxx:/vol/banques/.snapshot on /mount/banques_rel-v2 type nfs
(rw,nfsvers=2,addr=157.99.64.123)
emmental.xxx:/vol/banques/.snapshot on /mount/banques_rel type nfs
(rw,nfsvers=3,addr=157.99.64.123)

The correct answer from a nfs v2 x86_64 NetBSD machine:
Filesystem                                          1K-blocks      Used    
Avail Capacity  Mounted on
emmental.xxx:/vol/banques/.snapshot/prod 625152980 695404644 -70251664   111%  
 /mount/banks2

* The real value for the exported size is 625152980 according to the NetApp
not 625152984 (v2 on RHEL3 and v2,v3 on RHEL4)
not 625152992 (v3 on RHEL3)

* the real value for the Used space is 695404644 according to the NetApp

* the Used/Available size don't make sense, but I can understand it,
but at least they must be the same


Expected results:

correct size of exported share.
consistent value between nfsv2 and v3.

Additional info:
Comment 1 Tru Huynh 2005-07-04 09:37:20 EDT
2.4.21-15.0.4.ELsmp and df from coreutils-4.5.3-26 x86_64 has the correct and
consistent answers for the device size:
- df output
emmental.xxx/vol/banques/.snapshot
               nfs   625152980 -9223372020438584936 17041343852 101% /banques
emmental.xxx:/vol/banques/.snapshot
               nfs   625152980 -73786976278422011904 17041343852 101% /banques-v2
- mount output
emmental.xxx:/vol/banques/.snapshot on /banques type nfs
(ro,nfsvers=3,addr=157.99.xxx)
emmental.xxx:/vol/banques/.snapshot on /banques-v2 type nfs
(ro,nfsvers=2,addr=157.99.xxx)

the 2.4.21-32.0.1.ELsmp x86_64 at the same time :

emmental.xxx:/vol/banques/.snapshot
                     625152992 -590295810342289473536 17041343840 101%
/mount/banques_rel
emmental.xxx:/vol/banques/.snapshot
                     625152984 -147573952573260218368 17041343816 101%
/mount/banques_rel-v2

emmental.xxx:/vol/banques/.snapshot on /mount/banques_rel type nfs
(rw,addr=157.99.xxx)
emmental.xxx/vol/banques/.snapshot on /mount/banques_rel-v2 type nfs
(rw,nfsvers=2,addr=157.99.xxx)
Comment 3 Tru Huynh 2005-07-12 13:13:09 EDT
quick update: the snapshot size is now under 100% and the value reported in the
Available field is correct. It still does not explain the blocksize issue.

The machines have not been rebooted. Only the snapshot has changed.

2.4.21-15.0.4.ELsmp/x86_64
               nfs   625152980  16759284 608393696   3% /banques
               nfs   625152980  16759284 608393696   3% /banques-v2
2.6.9-11.ELsmp/x86_64
               nfs   625152984  16759288 608393696   3% /mount/banques_rel
               nfs   625152984  16759288 608393696   3% /mount/banques_rel-v2
2.4.21-32.0.1.ELsmp/x86_64
                     625152992  16759296 608393696   3% /mount/banques_rel
                     625152984  16759288 608393696   3% /mount/banques_rel-v2
NetBSD x86_64 current
625152980  16759284 608393696     2%    /mount/banks2
625152980  16759284 608393696     2%    /mount/banks3
mount -vvv:
emmental.sis.xxx:/vol/banques/.snapshot/prod on /mount/banks2 type nfs (fsid:
0xb02/0x70b, reads: sync 0 async 0, writes: sync 0 async 0, [nfs:
addr=xxx.xxx.xxx.xxx, port=2049, addrlen=16, sotype=2, proto=0, fhsize=0,
flags=0x8080<noconn,resvport>, wsize=8192, rsize=8192, readdirsize=8192,
timeo=300, retrans=10, maxgrouplist=16, readahead=2, leaseterm=30, deadthresh=9])
emmental.sis.xxx:/vol/banques/.snapshot/prod on /mount/banks3 type nfs (fsid:
0xb03/0x70b, reads: sync 0 async 0, writes: sync 0 async 0, [nfs:
addr=xxx.xxx.xxx.xxx, port=2049, addrlen=16, sotype=2, proto=0, fhsize=0,
flags=0x8280<noconn,nfsv3,resvport>, wsize=32768, rsize=32768, readdirsize=8192,
timeo=300, retrans=10, maxgrouplist=16, readahead=2, leaseterm=30, deadthresh=9])
Comment 7 RHEL Product and Program Management 2007-10-19 14:59:21 EDT
This bug is filed against RHEL 3, which is in maintenance phase.
During the maintenance phase, only security errata and select mission
critical bug fixes will be released for enterprise products. Since
this bug does not meet that criteria, it is now being closed.
 
For more information of the RHEL errata support policy, please visit:
http://www.redhat.com/security/updates/errata/
 
If you feel this bug is indeed mission critical, please contact your
support representative. You may be asked to provide detailed
information on how this bug is affecting you.

Note You need to log in before you can comment on or make changes to this bug.